/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_AUDIO_SESSION_H__
#define __XMPP_AUDIO_SESSION_H__

#include <glib.h>
#include <glib-object.h>

#include <tapioca/core/tapioca_audio_session.h>

#include "xmpp_client_c.h"
#include "xmpp_call_c.h"

G_BEGIN_DECLS

/* TYPE MACROS */
#define XMPP_TYPE_AUDIO_SESSION             (xmpp_audio_session_get_type())
#define XMPP_AUDIO_SESSION(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), XMPP_TYPE_AUDIO_SESSION, XmppAudioSession))
#define XMPP_AUDIO_SESSION_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST((klass), XMPP_TYPE_AUDIO_SESSION, XmppAudioSessionClass))
#define IS_XMPP_AUDIO_SESSION(obj)          (G_TYPE_CHECK_INSTANCE_TYPE((obj), XMPP_TYPE_AUDIO_SESSION))
#define IS_XMPP_AUDIO_SESSION_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE((klass), XMPP_TYPE_AUDIO_SESSION))
#define XMPP_AUDIO_SESSION_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), XMPP_TYPE_AUDIO_SESSION, XmppAudioSessionClass))
#define XMPP_AUDIO_SESSION_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE ((obj), XMPP_TYPE_AUDIO_SESSION, XmppAudioSessionPrivate))

typedef struct _XmppAudioSession        XmppAudioSession;
typedef struct _XmppAudioSessionClass   XmppAudioSessionClass;
typedef struct _XmppAudioSessionPrivate XmppAudioSessionPrivate;

struct _XmppAudioSessionClass {
    TapiocaAudioSessionClass parent_class;
};

struct _XmppAudioSession {
    TapiocaAudioSession parent;

    XmppAudioSessionPrivate *priv;
};

GType             xmpp_audio_session_get_type      (void);

XmppAudioSession *xmpp_audio_session_new           (xmpp_client_t client); 
XmppAudioSession *xmpp_audio_session_new_with_call (xmpp_client_t client,
                                                    xmpp_call_t call); 

G_END_DECLS

#endif
