/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_CALL_SESSION_DESCRIPTION_H__
#define __XMPP_CALL_SESSION_DESCRIPTION_H__

#include <talk/p2p/base/sessiondescription.h>

#include <vector>
#include <string>

class XmppCallSessionDescription : public cricket::SessionDescription {
public:
    struct Codec {
        int id;
        std::string name;
        int rate;
        int channels;
        int preference;

        Codec(int pt, const std::string& nm, int rt, int cn, int pr) : id(pt), name(nm), rate(rt), channels(cn), preference(pr) {}
        bool operator<(const Codec& c) const { return preference > c.preference; }
    };
    
    const std::vector<Codec>& codecs() const { return codecs_; }
    void AddCodec(const Codec& codec) { codecs_.push_back(codec); }
    void Sort() { std::stable_sort(codecs_.begin(), codecs_.end()); }

private:
    std::vector<Codec> codecs_;
};

#endif 
