/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "xmpp_call_session_description_c.h"
#include "xmpp_call_session_description.h"

xmpp_call_session_description_t
xmpp_call_session_description_new (void)
{
    XmppCallSessionDescription *session_description = new XmppCallSessionDescription();
    return (xmpp_call_session_description_t) session_description;
}

void
xmpp_call_session_description_destroy (xmpp_call_session_description_t session_description)
{
    XmppCallSessionDescription *sd = reinterpret_cast<XmppCallSessionDescription *>(session_description);
    delete sd;
}

void
xmpp_call_session_description_add_codec (xmpp_call_session_description_t session_description,
                                         int pt,
                                         const char *encoding_name,
                                         int rate, 
                                         int channels,
                                         int preference)
{
    XmppCallSessionDescription *sd = reinterpret_cast<XmppCallSessionDescription *>(session_description);
    sd->AddCodec (XmppCallSessionDescription::Codec(pt, encoding_name, rate, channels, preference));
}
    
unsigned int
xmpp_call_session_description_get_codecs_count (xmpp_call_session_description_t session_description)
{
    XmppCallSessionDescription *sd = reinterpret_cast<XmppCallSessionDescription *>(session_description);
    return sd->codecs().size();
}

void
xmpp_call_session_description_get_codec (xmpp_call_session_description_t session_description,
                                         unsigned int index,
                                         int *pt,
                                         const char **encoding_name,
                                         int *rate,
                                         int *channels,
                                         int *preference)
{
    XmppCallSessionDescription *sd = reinterpret_cast<XmppCallSessionDescription *>(session_description);
    const XmppCallSessionDescription::Codec &codec = sd->codecs()[index];
    *pt = codec.id;
    *encoding_name = codec.name.c_str ();
    *rate = codec.rate;
    *channels = codec.channels;
    *preference = codec.preference;
}
