/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_CALL_SESSION_DESCRIPTION_C_H__
#define __XMPP_CALL_SESSION_DESCRIPTION_C_H__

#ifdef __cplusplus
extern "C" {
#endif

typedef void* xmpp_call_session_description_t;

xmpp_call_session_description_t 
             xmpp_call_session_description_new              (void);
void         xmpp_call_session_description_destroy          (xmpp_call_session_description_t session_description);
void         xmpp_call_session_description_add_codec        (xmpp_call_session_description_t session_description,
                                                             int pt,
                                                             const char *encoding_name,
                                                             int rate,
                                                             int channels,
                                                             int preference);
unsigned int xmpp_call_session_description_get_codecs_count (xmpp_call_session_description_t session_description);
void         xmpp_call_session_description_get_codec        (xmpp_call_session_description_t session_description,
                                                             unsigned int index,
                                                             int *pt,
                                                             const char **encoding_name,
                                                             int *rate,
                                                             int *channels,
                                                             int *preference);

#ifdef __cplusplus
}
#endif

#endif
