/*
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_CALL_SESSION_MESSAGE_FACTORY_H__
#define __XMPP_CALL_SESSION_MESSAGE_FACTORY_H__

#include <talk/p2p/base/sessionmessagefactory.h>
#include <talk/p2p/client/xmppsessionmessage.h>

#include <sstream>

class XmppCallSessionMessageFactory : public cricket::SessionMessageFactory 
{
public:
    XmppCallSessionMessageFactory() { }
    virtual cricket::SessionMessage *CreateSessionMessage() 
    {
        cricket::SessionMessage *result = new cricket::XmppSessionMessage();
        result->set_message_id(NextId());
        return result;
    }
   
private:
    std::string NextId() {
        static int next_id = 0;
        std::stringstream ss("session");
        ss << next_id++;
        return ss.str();
    }
};

#endif
