/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_CANDIDATE_C_H__
#define __XMPP_CANDIDATE_C_H__

#ifdef __cplusplus
extern "C" {
#endif

typedef void* xmpp_candidate_t;

xmpp_candidate_t xmpp_candidate_new                 (void);
void             xmpp_candidate_destroy             (xmpp_candidate_t candidate);

void             xmpp_candidate_set_name            (xmpp_candidate_t candidate, const char *name);
void             xmpp_candidate_set_protocol        (xmpp_candidate_t candidate, const char *protocol);
void             xmpp_candidate_set_address         (xmpp_candidate_t candidate, const char *ip, unsigned int port);
void             xmpp_candidate_set_preference      (xmpp_candidate_t candidate, float preference);
void             xmpp_candidate_set_preference_str  (xmpp_candidate_t candidate, const char *preference);
void             xmpp_candidate_set_username        (xmpp_candidate_t candidate, const char *username);
void             xmpp_candidate_set_password        (xmpp_candidate_t candidate, const char *password);
void             xmpp_candidate_set_type            (xmpp_candidate_t candidate, const char *type);
void             xmpp_candidate_set_network_name    (xmpp_candidate_t candidate, const char *network_name);
void             xmpp_candidate_set_generation      (xmpp_candidate_t candidate, unsigned int generation);
void             xmpp_candidate_set_generation_str  (xmpp_candidate_t candidate, const char *generation);

const char      *xmpp_candidate_get_name            (xmpp_candidate_t candidate);
const char      *xmpp_candidate_get_protocol        (xmpp_candidate_t candidate);
void             xmpp_candidate_get_address         (xmpp_candidate_t candidate, const char **ip, unsigned int *port); 
float            xmpp_candidate_get_preference      (xmpp_candidate_t candidate);
const char      *xmpp_candidate_get_preference_str  (xmpp_candidate_t candidate);
const char      *xmpp_candidate_get_username        (xmpp_candidate_t candidate);
const char      *xmpp_candidate_get_password        (xmpp_candidate_t candidate);
const char      *xmpp_candidate_get_type            (xmpp_candidate_t candidate);
const char      *xmpp_candidate_get_network_name    (xmpp_candidate_t candidate);
unsigned int     xmpp_candidate_get_generation      (xmpp_candidate_t candidate);
const char      *xmpp_candidate_get_generation_str  (xmpp_candidate_t candidate);

#ifdef __cplusplus
}
#endif

#endif
