/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_CHAT_C_H__
#define __XMPP_CHAT_C_H__

#include "xmpp_chat_session_client_c.h"
#include "xmpp_message_c.h"
#include "xmpp_presence_push_c.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef void (* xmpp_chat_established_cb_type)      (xmpp_chat_t chat, 
                                                     void *data);
typedef void (* xmpp_chat_message_received_cb_type) (xmpp_chat_t chat, 
                                                     void *data,
                                                     xmpp_message_t message);
typedef void (* xmpp_chat_delivery_error_cb_type)   (xmpp_chat_t chat, 
                                                     void *data,
                                                     xmpp_message_t message,
                                                     int error_code);

const char *xmpp_chat_get_remote_jid          (xmpp_chat_t chat);
void        xmpp_chat_send_message            (xmpp_chat_t chat,
                                               const char *subject,
                                               const char *body);

void        xmpp_chat_set_established_cb      (xmpp_chat_t chat,
                                               xmpp_chat_established_cb_type cb,
                                               void *data);
void        xmpp_chat_set_message_received_cb (xmpp_chat_t chat,
                                               xmpp_chat_message_received_cb_type cb,
                                               void *data);
void        xmpp_chat_set_delivery_error_cb   (xmpp_chat_t chat,
                                               xmpp_chat_delivery_error_cb_type cb,
                                               void *data);

#ifdef __cplusplus
}
#endif

#endif
