/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "xmpp_chat_session_client_c.h"
#include "xmpp_chat_session_client.h"

xmpp_chat_t
xmpp_chat_session_client_create_chat (xmpp_chat_session_client_t chat_client,
                                      const char *remote_jid)
{
    XmppChatSessionClient *xc = reinterpret_cast<XmppChatSessionClient *>(chat_client);
    return (xmpp_chat_t) xc->CreateChat(buzz::Jid(remote_jid));
}

void
xmpp_chat_session_client_destroy_chat (xmpp_chat_session_client_t chat_client,
                                       xmpp_chat_t chat)
{
    XmppChatSessionClient *xc = reinterpret_cast<XmppChatSessionClient *>(chat_client);
    xc->DestroyChat(reinterpret_cast<XmppChat *>(chat));
}
