/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_CONNECTION_H__
#define __XMPP_CONNECTION_H__

#include <glib.h>
#include <glib-object.h>

#include <tapioca/core/tapioca_connection.h>

G_BEGIN_DECLS

/* TYPE MACROS */
#define XMPP_TYPE_CONNECTION            (xmpp_connection_get_type())
#define XMPP_CONNECTION(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), XMPP_TYPE_CONNECTION, XmppConnection))
#define XMPP_CONNECTION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), XMPP_TYPE_CONNECTION, XmppConnectionClass))
#define IS_XMPP_CONNECTION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), XMPP_TYPE_CONNECTION))
#define IS_XMPP_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), XMPP_TYPE_CONNECTION))
#define XMPP_CONNECTION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), XMPP_TYPE_CONNECTION, XmppConnectionClass))
#define XMPP_CONNECTION_GET_PRIVATE(obj)  (G_TYPE_INSTANCE_GET_PRIVATE ((obj), XMPP_TYPE_CONNECTION, XmppConnectionPrivate))

typedef struct _XmppConnection        XmppConnection;
typedef struct _XmppConnectionClass   XmppConnectionClass;
typedef struct _XmppConnectionPrivate XmppConnectionPrivate;

struct _XmppConnectionClass {
    TapiocaConnectionClass parent_class;
};

struct _XmppConnection {
    TapiocaConnection parent;

    XmppConnectionPrivate *priv;
};

GType                xmpp_connection_get_type          (void);

G_END_DECLS

#endif
