/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif 

#include "xmpp_connection_manager.h"
#include "xmpp_connection.h"

#include <tapioca/core/tapioca_enums.h>
#include <tapioca/core/tapioca_version.h>

static TapiocaConnection *xmpp_connection_manager_create_connection (TapiocaConnectionManager *tc, 
                                                                       GError **error);

G_DEFINE_TYPE(XmppConnectionManager, xmpp_connection_manager, TAPIOCA_TYPE_CONNECTION_MANAGER)

static void 
xmpp_connection_manager_class_init (XmppConnectionManagerClass *klass)
{
    GObjectClass *gobject_class;
    TapiocaConnectionManagerClass *tapioca_connection_manager_class;

    gobject_class = (GObjectClass *) klass;
    tapioca_connection_manager_class = (TapiocaConnectionManagerClass*) klass;
    xmpp_connection_manager_parent_class = g_type_class_peek_parent (klass);
    
    tapioca_connection_manager_class->create_connection = xmpp_connection_manager_create_connection;
}

static void 
xmpp_connection_manager_init (XmppConnectionManager *sc)
{
}

static TapiocaConnection *
xmpp_connection_manager_create_connection (TapiocaConnectionManager *tc,
                                           GError **error)
{
    return TAPIOCA_CONNECTION (g_object_new (XMPP_TYPE_CONNECTION, NULL));
}
