/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_CONNECTION_MANAGER_H__
#define __XMPP_CONNECTION_MANAGER_H__

#include <glib.h>
#include <glib-object.h>

#include <tapioca/core/tapioca_connection_manager.h>

G_BEGIN_DECLS

/* TYPE MACROS */
#define XMPP_TYPE_CONNECTION_MANAGER             (xmpp_connection_manager_get_type())
#define XMPP_CONNECTION_MANAGER(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), XMPP_TYPE_CONNECTION_MANAGER, XmppConnectionManager))
#define XMPP_CONNECTION_MANAGER_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST((klass), XMPP_TYPE_CONNECTION_MANAGER, XmppConnectionManagerClass))
#define IS_XMPP_CONNECTION_MANAGER(obj)          (G_TYPE_CHECK_INSTANCE_TYPE((obj), XMPP_TYPE_CONNECTION_MANAGER))
#define IS_XMPP_CONNECTION_MANAGER_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE((klass), XMPP_TYPE_CONNECTION_MANAGER))
#define XMPP_CONNECTION_MANAGER_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), XMPP_TYPE_CONNECTION_MANAGER, XmppConnectionManagerClass))
#define XMPP_CONNECTION_MANAGER_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE ((obj), XMPP_TYPE_CONNECTION_MANAGER, XmppConnectionManagerPrivate))

typedef struct _XmppConnectionManager      XmppConnectionManager;
typedef struct _XmppConnectionManagerClass XmppConnectionManagerClass;

struct _XmppConnectionManagerClass {
    TapiocaConnectionManagerClass parent_class;
};

struct _XmppConnectionManager {
    TapiocaConnectionManager parent;
};

GType xmpp_connection_manager_get_type (void);

G_END_DECLS

#endif
