/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Luiz Augusto von Dentz <luiz.dentz@indt.org.br> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_CONTACT_LIST_H__
#define __XMPP_CONTACT_LIST_H__

#include <glib.h>
#include <glib-object.h>

#include <tapioca/core/tapioca_contact_list.h>

#include "xmpp_roster_c.h"

G_BEGIN_DECLS

/* TYPE MACROS */
#define XMPP_TYPE_CONTACT_LIST             (xmpp_contact_list_get_type())
#define XMPP_CONTACT_LIST(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), XMPP_TYPE_CONTACT_LIST, XmppContactList))
#define XMPP_CONTACT_LIST_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST((klass), XMPP_TYPE_CONTACT_LIST, XmppContactListClass))
#define IS_XMPP_CONTACT_LIST(obj)          (G_TYPE_CHECK_INSTANCE_TYPE((obj), XMPP_TYPE_CONTACT_LIST))
#define IS_XMPP_CONTACT_LIST_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE((klass), XMPP_TYPE_CONTACT_LIST))
#define XMPP_CONTACT_LIST_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), XMPP_TYPE_CONTACT_LIST, XmppContactListClass))
#define XMPP_CONTACT_LIST_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE ((obj), XMPP_TYPE_CONTACT_LIST, XmppContactListPrivate))

typedef struct _XmppContactList        XmppContactList;
typedef struct _XmppContactListClass   XmppContactListClass;
typedef struct _XmppContactListPrivate XmppContactListPrivate;

struct _XmppContactListClass {
    TapiocaContactListClass parent_class;
};

struct _XmppContactList {
    TapiocaContactList parent;

    XmppContactListPrivate *priv;
};

GType           xmpp_contact_list_get_type   (void);

XmppContactList *xmpp_contact_list_new       (void);

void            xmpp_contact_list_initialize (XmppContactList *xcl,
                                              xmpp_roster_t *roster);
G_END_DECLS

#endif
