/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_PRESENCE_H__
#define __XMPP_PRESENCE_H__

#include <glib.h>
#include <glib-object.h>

#include <tapioca/core/tapioca_presence.h>

#include "xmpp_presence_out_c.h"
#include "xmpp_presence_push_c.h"

G_BEGIN_DECLS

/* TYPE MACROS */
#define XMPP_TYPE_PRESENCE             (xmpp_presence_get_type())
#define XMPP_PRESENCE(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), XMPP_TYPE_PRESENCE, XmppPresence))
#define XMPP_PRESENCE_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST((klass), XMPP_TYPE_PRESENCE, XmppPresenceClass))
#define IS_XMPP_PRESENCE(obj)          (G_TYPE_CHECK_INSTANCE_TYPE((obj), XMPP_TYPE_PRESENCE))
#define IS_XMPP_PRESENCE_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE((klass), XMPP_TYPE_PRESENCE))
#define XMPP_PRESENCE_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), XMPP_TYPE_PRESENCE, XmppPresenceClass))
#define XMPP_PRESENCE_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE ((obj), XMPP_TYPE_PRESENCE, XmppPresencePrivate))

typedef struct _XmppPresence        XmppPresence;
typedef struct _XmppPresenceClass   XmppPresenceClass;
typedef struct _XmppPresencePrivate XmppPresencePrivate;

struct _XmppPresenceClass {
    TapiocaPresenceClass parent_class;
};

struct _XmppPresence {
    TapiocaPresence parent;

    XmppPresencePrivate *priv;
};

GType         xmpp_presence_get_type   (void);

XmppPresence *xmpp_presence_new        (void);
void          xmpp_presence_initialize (XmppPresence *xp,
                                        xmpp_presence_out_t presence_out,
                                        xmpp_presence_push_t presence_push);

G_END_DECLS

#endif
