/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "xmpp_presence_out_c.h"

#include "presenceouttask.h"
#include "status.h"

#include <talk/xmpp/xmppclient.h>

void 
xmpp_presence_out_set_status (xmpp_presence_out_t presence_out,
                              unsigned int status,
                              const char *status_desc)
{
    buzz::PresenceOutTask *po = reinterpret_cast<buzz::PresenceOutTask *>(presence_out);
    buzz::Status my_status;
    my_status.set_jid(po->GetClient()->jid());
    if (status == buzz::Status::SHOW_OFFLINE ||
        status == buzz::Status::SHOW_NONE)
        my_status.set_available(false);
    else {
        my_status.set_available(true);
        my_status.set_show((buzz::Status::Show) status);
        if (status_desc && status != buzz::Status::SHOW_ONLINE)
            my_status.set_status(status_desc);
        my_status.set_priority(0);
        my_status.set_know_capabilities(true);
        my_status.set_phone_capability(true);
        my_status.set_is_google_client(true);
        my_status.set_version("1.0.0.66");
    }

    po->Send(my_status);
    po->Step();
}
