/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "xmpp_presence_push_c.h"
#include "xmpp_presence_push.h"

#include <talk/xmpp/xmppclient.h>

void
xmpp_presence_push_request_status (xmpp_presence_push_t presence_push,
                                   const char *jid)
{
    XmppPresencePush *pp = reinterpret_cast<XmppPresencePush *>(presence_push);
    pp->RequestStatus(buzz::Jid(jid));
}

int
xmpp_presence_push_has_phone_capability (xmpp_presence_push_t presence_push,
                                         const char *jid)
{
    XmppPresencePush *pp = reinterpret_cast<XmppPresencePush *>(presence_push);
    if (pp->has_phone_capability (buzz::Jid(jid)))
        return 1;
    return 0;
}

void 
xmpp_presence_push_set_status_updated_cb (xmpp_presence_push_t presence_push,
                                          xmpp_presence_push_status_updated_cb_type cb,
                                          void *data)
{
    XmppPresencePush *pp = reinterpret_cast<XmppPresencePush *>(presence_push);
    pp->SetStatusUpdatedCb (cb, data);
}
