/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_PRESENCE_PUSH_C_H__
#define __XMPP_PRESENCE_PUSH_C_H__

#ifdef __cplusplus
extern "C" {
#endif

typedef void* xmpp_presence_push_t;
   
typedef void (* xmpp_presence_push_status_updated_cb_type) (xmpp_presence_push_t presence_push,
                                                            void *data, 
                                                            const char *jid,
                                                            unsigned int status,
                                                            const char *status_desc,
                                                            int phone_capability);

void xmpp_presence_push_request_status        (xmpp_presence_push_t presence_push,
                                               const char *jid);
int  xmpp_presence_push_has_phone_capability  (xmpp_presence_push_t presence_push,
                                               const char *jid);

void xmpp_presence_push_set_status_updated_cb (xmpp_presence_push_t presence_push,
                                               xmpp_presence_push_status_updated_cb_type cb,
                                               void *data);

#ifdef __cplusplus
}
#endif

#endif
