/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Luiz Augusto von Dentz <luiz.dentz@indt.org.br> 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_ROSTER_C_H__
#define __XMPP_ROSTER_C_H__

#ifdef __cplusplus
extern "C" {
#endif

typedef void* xmpp_roster_t;
   
typedef void (* xmpp_roster_deny_authorize_cb_type) (xmpp_roster_t roster,
                                                     void *data,
                                                     const char *jid);
typedef void (* xmpp_roster_contact_retrieved_cb_type)
                                                    (xmpp_roster_t roster,
                                                     void *data,
                                                     const char *jid,
                                                     const char *name,
                                                     const char *subscription,
                                                     const char *group);
typedef void (* xmpp_roster_info_retrieved_cb_type) (xmpp_roster_t roster,
                                                     void *data,
                                                     const char *jid,
                                                     const char *info);
void        xmpp_roster_deny_contact                (xmpp_roster_t roster,
                                                     const char *jid);
void        xmpp_roster_authorize_contact           (xmpp_roster_t roster,
                                                     const char *jid);
void        xmpp_roster_request_contacts            (xmpp_roster_t roster);
void        xmpp_roster_request_info                (xmpp_roster_t roster,
                                                     const char *jid);
void        xmpp_roster_add_contact                 (xmpp_roster_t roster,
                                                     const char *jid,
                                                     const char *name,
                                                     const char *group);
void        xmpp_roster_remove_contact              (xmpp_roster_t roster,
                                                     const char *jid);
void        xmpp_roster_set_contact_denied_cb       (xmpp_roster_t roster,
                                                     xmpp_roster_deny_authorize_cb_type cb,
                                                     void *data);
void        xmpp_roster_set_contact_authorized_cb   (xmpp_roster_t roster,
                                                     xmpp_roster_deny_authorize_cb_type cb,
                                                     void *data);
void        xmpp_roster_set_authorization_requested_cb
                                                    (xmpp_roster_t roster,
                                                     xmpp_roster_deny_authorize_cb_type cb,
                                                     void *data);
void        xmpp_roster_set_contact_retrieved_cb    (xmpp_roster_t roster,
                                                     xmpp_roster_contact_retrieved_cb_type cb,
                                                     void *data);
void        xmpp_roster_set_info_retrieved_cb       (xmpp_roster_t roster,
                                                     xmpp_roster_info_retrieved_cb_type cb,
                                                     void *data);
#ifdef __cplusplus
}
#endif

#endif
