/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_TEXT_SESSION_H__
#define __XMPP_TEXT_SESSION_H__

#include <glib.h>
#include <glib-object.h>

#include <tapioca/core/tapioca_text_session.h>

#include "xmpp_client_c.h"
#include "xmpp_chat_c.h"

G_BEGIN_DECLS

/* TYPE MACROS */
#define XMPP_TYPE_TEXT_SESSION             (xmpp_text_session_get_type())
#define XMPP_TEXT_SESSION(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), XMPP_TYPE_TEXT_SESSION, XmppTextSession))
#define XMPP_TEXT_SESSION_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST((klass), XMPP_TYPE_TEXT_SESSION, XmppTextSessionClass))
#define IS_XMPP_TEXT_SESSION(obj)          (G_TYPE_CHECK_INSTANCE_TYPE((obj), XMPP_TYPE_TEXT_SESSION))
#define IS_XMPP_TEXT_SESSION_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE((klass), XMPP_TYPE_TEXT_SESSION))
#define XMPP_TEXT_SESSION_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), XMPP_TYPE_TEXT_SESSION, XmppTextSessionClass))
#define XMPP_TEXT_SESSION_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE ((obj), XMPP_TYPE_TEXT_SESSION, XmppTextSessionPrivate))

typedef struct _XmppTextSession        XmppTextSession;
typedef struct _XmppTextSessionClass   XmppTextSessionClass;
typedef struct _XmppTextSessionPrivate XmppTextSessionPrivate;

struct _XmppTextSessionClass {
    TapiocaTextSessionClass parent_class;
};

struct _XmppTextSession {
    TapiocaTextSession parent;

    XmppTextSessionPrivate *priv;
};

GType            xmpp_text_session_get_type      (void);

XmppTextSession *xmpp_text_session_new           (xmpp_client_t client);
XmppTextSession *xmpp_text_session_new_with_chat (xmpp_client_t client,
                                                  xmpp_chat_t chat);

G_END_DECLS

#endif
