/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "xmpp_thread_c.h"

#include <talk/base/physicalsocketserver.h>
#include <talk/base/thread.h>

xmpp_thread_t
xmpp_thread_new (void)
{
    cricket::PhysicalSocketServer *ss = new cricket::PhysicalSocketServer();
    cricket::Thread *ct = new cricket::Thread(ss);
    return (xmpp_thread_t) ct;
}

void
xmpp_thread_start (xmpp_thread_t thread)
{
    cricket::Thread *ct = reinterpret_cast<cricket::Thread *>(thread);
    ct->Start();
}

void
xmpp_thread_manager_set_current (xmpp_thread_t thread)
{
    cricket::Thread *ct = reinterpret_cast<cricket::Thread *>(thread);
    cricket::ThreadManager::SetCurrent(ct);
}

void
xmpp_thread_loop (xmpp_thread_t thread, int cms)
{
    cricket::Thread *ct = reinterpret_cast<cricket::Thread *>(thread);
    ct->Loop (cms);
}
